﻿#!/usr/bin/python
# -*- coding: utf-8 -*-
from PyQt4 import QtGui, QtCore
import sys, form, os

path_pic = "./photo/"
path_txt = "./info/"
vopr = open("voprosy.txt", "r")
rv = vopr.read()
Instance = QtCore.QObject
new_wins = []
pics = []
otv = []
	
photo = [
	'smolensk',
	'gagarin',
	'nahimov',
	'egorov',
	'coldunov',
	'kasatkina',
	'konenkov',
	'nikulin',
	'papanov',
	'plotnikov',
	'rumjanceva',
	'tvardovskij',
	'yuriev',
	'lavochkin',
	'dnepr',
	'flenovo',
	'lakes'
]

ans = [
	[3, 4, 1, 1, 0],
	[3, 0, 1, 1, 2],
	[3, 1, 4, 2, 0],
	[4, 2, 0, 1, 3],
	[2, 1, 3, 0, 3]
]

def trans(Instance, SText):
	return QtCore.QObject.trUtf8(Instance, SText)
	
class SmolMap(QtGui.QMainWindow):
	global path_pic, path_txt, photo, new_wins, rv, pics
	def __init__(self, parent = None):
		global pics
		QtGui.QMainWindow.__init__(self)
		
		self.setWindowTitle(u"Культура Смоленщины под призмой ГИС")
		self.setWindowIcon(QtGui.QIcon(path_pic + "SmolObl.jpg"))
		
		self.scene = Scene() # группа из карты и картинок на ней
		
		krt = QtGui.QGraphicsView(self.scene, self)
		krt.setRenderHint(QtGui.QPainter.Antialiasing)
		krt.setBackgroundBrush(QtGui.QBrush(QtGui.QPixmap("SmolenskOblast.jpg")))
		krt.setCacheMode(QtGui.QGraphicsView.CacheBackground)
		krt.setViewportUpdateMode(QtGui.QGraphicsView.BoundingRectViewportUpdate)
		
		exit = QtGui.QAction(u'Выход', self)
		exit.setShortcut('Ctrl+Q')
		exit.setStatusTip(u'Закрыть приложение')
		self.connect(exit, QtCore.SIGNAL('triggered()'), QtCore.SLOT('close()'))
		
		about = QtGui.QAction(u'О программе...', self)
		about.setShortcut("F1")
		about.setStatusTip(u'Информация пользователю')
		self.connect(about, QtCore.SIGNAL('triggered()'), self.who)
		
		sbros = QtGui.QAction(u'Сброс', self)
		sbros.setStatusTip(u'Вернуть картинки на первоначальные места')
		self.connect(sbros, QtCore.SIGNAL('triggered()'), self.clear)
		
		victor = QtGui.QAction(u"Проверь себя!", self)
		victor.setStatusTip(u"Тесты на разные вопросы")
		self.connect(victor, QtCore.SIGNAL('triggered()'), self.test)
		
		openCoord = QtGui.QAction(u'Открыть...', self)
		openCoord.setStatusTip(u"Открыть существующий файл")
		openCoord.setShortcut("Ctrl+O")
		self.connect(openCoord, QtCore.SIGNAL('triggered()'), self.opn)
		
		saveCoord = QtGui.QAction(u'Сохранить как...', self)
		saveCoord.setStatusTip(u"Сохранить файл")
		saveCoord.setShortcut("Ctrl+S")
		self.connect(saveCoord, QtCore.SIGNAL('triggered()'), self.sve)
		
		self.statusBar()

		menubar = self.menuBar()
		file = menubar.addMenu(u'&Меню')
		help = menubar.addMenu("&?")
		help.addAction(about)
		file.addAction(openCoord)
		file.addAction(saveCoord)
		file.addAction(victor)
		file.addAction(sbros)
		file.addAction(exit)
		
		frame = QtGui.QFrame()        
		fLt = QtGui.QHBoxLayout(frame)
		self.karta = krt
		fLt.addWidget(krt)
		
		pics = [Elem(QtGui.QPixmap(path_pic + photo[i] + ".jpg"), i, self.scene)
			for i in xrange(len(photo))]
		self.clear()
		
		self.setCentralWidget(frame)
		self.resize(1024, 768)
		
	def opn(self):
		global pics
		fileName = QtGui.QFileDialog.getOpenFileName(self)
		if fileName:
			fin = open(fileName, "r")
			inp = fin.read().split()
			k = len(inp) / 2
			for i in xrange(k):
				j = 0
				t = inp.pop(0)
				while t[j] != '(': j += 1
				j += 1
				s1 = ""
				while t[j] != '.': 
					s1 += t[j]
					j += 1
				x = int(s1)
				t = inp.pop(0)
				s2 = ""
				j = 0
				while t[j] != '.': 
					s2 += t[j]
					j += 1
				y = int(s2)
				pics[i].setPos(x, y)
				
	def sve(self):
		global pics
		fileName = QtGui.QFileDialog.getSaveFileName(self)
		if fileName:
			fout = open(fileName, "w")
			for i in pics:
				print >> fout, i.pos()
	
	def clear(self):
		global pics
		for i in xrange(len(pics)):
			pics[i].setPos(i * 150, 0)
			
	def closeEvent(self, event):
		reply = QtGui.QMessageBox.question(self, u'Выход',
			u"Вы действительно хотите выйти?", QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
		if reply == QtGui.QMessageBox.Yes: 
			event.accept()
		else:
			event.ignore()
	
	def who(self):
		QtGui.QMessageBox.about(self, u"О проекте", 
			u"Данный проект предоставляет\n пользователю возможность\n  работы с картой, а также\n содержит информацию о некоторых\n известных смоленских людях\n и местах.\n \n Изображения знаменитостей находятся\n вверху, щелкните по пиктограмме\n правой кнопкой мыши и появиться\n информация об объекте. Изображения\n можно перетаскивать и сохранять\n их местоположение. Еще в программе\n есть набор тестов на различные тематики.\n\n Автор Коваников Д. В.©, 2011\n ")

	def test(self):
		t = vtest()
		new_wins.append(t)
		new_wins[len(new_wins) - 1].show()
		
class Scene(QtGui.QGraphicsScene):
	global pics
	def __init__(self, parent = None):
		QtGui.QGraphicsScene.__init__(self, parent)
		self.setSceneRect(0, 0, 2880, 2529)
		#self.setItemIndexMethod(QtGui.QGraphicsScene.NoIndex)
		
	def dragEnterEvent(self, event):
		item = event.mimeData().Elem
		# временный "затемнённый" рисунок перетаскиваемой картинки:
		tempPixmap = QtGui.QPixmap(item.pixmap())
		painter = QtGui.QPainter()
		painter.begin(tempPixmap)
		painter.fillRect(item.pixmap().rect(), QtGui.QColor(127, 127, 127, 127))
		painter.end()
		item.setPixmap(tempPixmap)
	
	def dragLeaveEvent(self, event):
		item = event.mimeData().Elem
		# восстанавливаем рисунок перетаскиваемой картинки:
		pixmap = QtGui.QPixmap(event.mimeData().imageData())
		item.setPixmap(pixmap)
    
    # в процессе выполнения операции drag and drop
	def dragMoveEvent(self, event):
		pass
    
    # завершение операции drag and drop
	def dropEvent(self, event):
		global pics
		# создание копии перенесённого элемента на новом месте:
		pixmap = QtGui.QPixmap(event.mimeData().imageData())
		t = event.mimeData().Elem
		item = Elem(pixmap, t.ind, self)
		# установка положения элемента,
		# координаты курсора мыши на сцене корректируем координатами курсора мыши на элементе:
		pics.insert(t.ind, item)
		pics.pop(t.ind + 1)
		pics[t.ind].setPos(event.scenePos() - event.mimeData().Pos)
        # удаление перенесённого элемента:
		self.removeItem(event.mimeData().Elem)
		
class Elem(QtGui.QGraphicsPixmapItem):
	global new_wins, otv
	def __init__(self, pixmap, indx = 0, scene = None, parent = None):
		QtGui.QGraphicsPixmapItem.__init__(self, pixmap, parent, scene)
		
		self.setPixmap(QtGui.QPixmap(pixmap))
		self.ind = indx
			
	def mousePressEvent(self, event):
		global otv
		if event.button() == QtCore.Qt.LeftButton:
			drag = QtGui.QDrag(event.widget()) # объект Drag
			mime = QtCore.QMimeData()
			mime.setImageData(QtCore.QVariant(self.pixmap())) # запоминаем рисунок
			mime.Pos = event.pos() # запоминаем позицию события в координатах элемента
			mime.Elem = self # запоминаем сам элемент, который переносится
			drag.setMimeData(mime)
        
			drag.setPixmap(self.pixmap()) # рисунок, отображающийся в процессе переноса
			drag.setHotSpot(event.pos().toPoint()) # позиция "ухватки"
        
			drag.start() # запуск (начало) перетаскивания
		else:
			otv = []
			inf = InfoWin(self.ind, None)
			new_wins.append(inf)
			new_wins[len(new_wins) - 1].show()
		
class InfoWin(QtGui.QWidget):
	global photo, path_txt, path_pic
	def __init__(self, num = 0, parent = None):
		QtGui.QWidget.__init__(self, parent)
		
		self.setWindowTitle(photo[num])
		self.setWindowIcon(QtGui.QIcon(path_pic + photo[num] + '.jpg'))
		self.resize(600, 700)
		
		lt = QtGui.QVBoxLayout()
		
		info_edit = QtGui.QTextEdit()
		f = open(path_txt + photo[num] + '.txt')
		text = f.read()
		info_edit.setText(trans(app, text))
		
		lt.addWidget(info_edit)
		self.setLayout(lt)

class vtest(QtGui.QWidget, form.Ui_Form):
	global rv, rub, ans, otv
	def __init__(self, parent = None, deep = 0, rub = 0):
		global otv
		super(vtest, self).__init__(parent)
		self.setupUi(self)
		
		self.var = []
		self.var.append(self.Rb1)
		self.var.append(self.Rb2)
		self.var.append(self.Rb3)
		self.var.append(self.Rb4)
		self.var.append(self.Rb5)
		
		self.quest.setText(u"Выберите рубрику")
		self.deep = deep
		self.rub = rub
		
		if deep == 0:
			self.connect(self.but, QtCore.SIGNAL('clicked()'), self.first)
		else:
			self.connect(self.but, QtCore.SIGNAL('clicked()'), self.next)
			if self.deep <= 5:
				source = self.q_poisk(self.rub, self.deep)
				self.quest.setText(trans(app, source[0]))
				for i in xrange(5):
					self.var[i].setText(trans(app, source[1][i]))
			
	def first(self):
		global new_wins
		for i in xrange(5):
			if self.var[i].isChecked() == 1:
				b = i + 1
		del new_wins[len(new_wins) - 1] # = self.close()
		new_wins.append(vtest(None, 1, b)) # сразу же создает новое окно
		new_wins[len(new_wins) - 1].show()
	
	def next(self):
		global ans, new_wins
		for i in xrange(5):
			if self.var[i].isChecked() == 1: otv.append(i)
		if self.deep >= 5:
			col = 0
			for i in xrange(5):
				if otv[i] == ans[self.rub-1][i]: col += 1
			del new_wins[len(new_wins) - 1]
			QtGui.QMessageBox.about(self, u"Все", 
				u"Вы набрали %d баллов из 5" % (col))
		else:
			del new_wins[len(new_wins) - 1] # = self.close()
			new_wins.append(vtest(None, self.deep + 1, self.rub)) # сразу же создает новое окно
			new_wins[len(new_wins) - 1].show()
		
	def q_poisk(self, nr, nq):
		global rv
		s = ""; j = 0; a = []
		for i in xrange(len(rv) - 1):
			if(rv[i] == '&' and int(rv[i+1]) == nr):
				j = i + 3
				break
		p = 1
		while(j < len(rv) and rv[j] != '&' and p):
			if rv[j] == '$' and int(rv[j+1]) == nq:
				s = "" # в s - вопросы
				while rv[j] != '#': 
					s += rv[j]; j += 1
				st = "" # в st - ответы
				a = [] # содержит все возможные ответы для текущего вопроса
				i = -1
				while(j != len(rv) and rv[j] != '$' and rv[j] != '&'):
					if rv[j] == '#':
						st = ""
						a.append(st)
						i += 1; j += 1
					a[i] += rv[j]
					j += 1
				p = 0
			j += 1
		x = s.split()
		x.pop(0)
		s = ""
		for i in x: s += i + " "
		for i in xrange(len(a)):
			a[i] = a[i].split()
			sv = ""
			for j in xrange(len(a[i])): sv += a[i][j] + " "
			a[i] = sv
		res = [s, a] # возвращает вопрос и ответы
		return res
			
if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	m = SmolMap()
	m.show()
	app.exec_()